# Copyright (c) 2008-2009 gocept gmbh & co. kg
# See also LICENSE.txt
# $Id: resourcegroup.py 14177 2009-01-11 21:39:39Z thomas $

import grok
import zope.component
import zope.interface

import gocept.directory.form
import gocept.directory.interfaces
import gocept.reference


class ResourceGroup(grok.Model):

    grok.implements(gocept.directory.interfaces.IResourceGroup)

    gid = None

    persons = gocept.reference.ReferenceCollection(ensure_integrity=True)

    def __init__(self, group='', title=u''):
        self.group = group
        self.title = title
        self.persons = set()


class Index(gocept.directory.form.BasicEditForm):

    extra_content = u'@@containers'
    redirect_to_parent = False


class Containers(grok.View):

    def persons(self):
        for person in sorted(self.context.persons,
                             key=gocept.directory.interfaces.ITitle):
            yield dict(title=gocept.directory.interfaces.ITitle(person),
                       url=self.url(person))


@grok.subscribe(ResourceGroup, grok.IObjectAddedEvent)
def allocate_gid(resourcegroup, event):
    gids = zope.component.getUtility(gocept.directory.interfaces.IPOSIXIds,
                                     name='gid')
    resourcegroup.gid = gids.register(resourcegroup)


class DefaultResourceGroup(object):
    """Implements a default group which is primary group for all users."""

    zope.interface.implements(gocept.directory.interfaces.IResourceGroup)

    def __init__(self):
        self.group = "users"
        self.title = "Default group"
        self.gid = 1000
        self.persons = set()


defaultgroup = DefaultResourceGroup()
